# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import grok
import megrok.pagelet
import gocept.directory.interfaces


class Location(grok.Container):

    grok.implements(gocept.directory.interfaces.ILocation)

    @property
    def directory(self):
        return self.__parent__

    @property
    def vlans(self):
        for obj in self.values():
            if gocept.directory.interfaces.IVLAN.providedBy(obj):
                yield obj

    @property
    def nodes(self):
        for rg in self.directory.resource_groups:
            for node in rg.nodes:
                if node.location is self:
                    yield node


class Index(megrok.pagelet.Pagelet):
    pass


class AddLocation(gocept.directory.form.AddForm):

    grok.context(gocept.directory.interfaces.IDirectory)
    form_fields = grok.AutoFields(gocept.directory.interfaces.ILocation)

    @grok.action('Add')
    def add(self, **kw):
        location = Location()
        self.applyData(location, **kw)
        self.context[kw['abbreviation']] = location
        self.status = u'Created location %s' % kw['title']
        self.redirect(self.url(location))
