# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: posixids.py 16508 2009-07-10 08:45:56Z ctheune $

import grok
import zope.app.intid


class POSIXIds(zope.app.intid.IntIds):

    def __init__(self, family=None):
        super(POSIXIds, self).__init__(family)
        self._min_value = 0
        self._max_value = self.family.maxint

    def setup(self, minimum=0, maximum=None):
        """Configure self to obey min and max values from int_field."""
        self._min_value = minimum
        if maximum is not None:
            assert maximum <= self.family.maxint
            self._max_value = maximum

    def _generateId(self):
        """Generate an id which is not yet taken.

        This tries to allocate sequential ids so they fall into the
        same BTree bucket, and randomizes if it stumbles upon a
        used one.
        """
        while True:
            if self._v_nextid is None:
                self._v_nextid = self._randrange(
                    self._min_value, self._max_value)
            uid = self._v_nextid
            self._v_nextid += 1
            if uid not in self.refs:
                return uid
            self._v_nextid = None
